	real*8 function gasstp(nfree, count, silent, dchimin)
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c  $Id: gasstp.f,v 5.15 2003/08/20 02:04:49 friedrich Exp $
c  this routine makes the fitting process by 
c  slowly adding parameters to the fitting procedure
c  it is seperated from the older verson of gasfit.f
c  f. Riess
c------------------------------------------------------------------
	implicit none
c if true: will write parameter of intermediate fits into
c parameter fil. Obsolete because displays can be saved directly
        integer KANAL
        parameter (KANAL = 3)
        logical AFTERSTEP
        parameter (AFTERSTEP = .TRUE.)
        logical OUTPAR
        parameter (OUTPAR = .false.)
	integer STEPCOUNT, MAXSTEP
	parameter (STEPCOUNT = 1000)
        parameter (MAXSTEP = 10)
	real*8 DCHISTEP
	parameter (DCHISTEP = 10.d+00)
        real*8 LIMIT
	parameter (LIMIT = 1.d+00)

	character*(*) FSTPVR
	parameter (FSTPVR='(''         peak-range:'',1f7.1)')
	character*(*) FSTPWR
	parameter (FSTPWR='(''         fwhm-range:'',1f7.1)')
	character*(*) FSTPVF
	parameter (FSTPVF='(''         fwhm fact.: '',10(f6.1,5x),
	12(/16x,10f11.1))')
	character*(*) FSTPTR
	parameter (FSTPTR='(''         tau L,B,R range:  '',10f9.1)')
	character*(*) FSTPCHF, FSTPCHG, FSTPCHS
	parameter (FSTPCHF='('' GASSTP:''i6'' chisq '',g15.8,'' dchirel'',
	1g9.2,'' step'',i2,'' nfree '',i4,'' flambda'',e8.1)')
	parameter (FSTPCHG='('' GASSTP: step'',i3,'' count ='',i6,'' chi '',g15.8,'' dchi'',
	1g9.2,'' chi/f'',g15.6,'' lambda'',e8.1)')
	parameter (FSTPCHS='(''         step'',i3,'' count ='',i6,'' chi '',g15.8,'' dchi'',
	1g9.2,'' chi/f'',g15.6,'' lambda'',e8.1)')
	character*(*) FSTPNOPA
	parameter (FSTPNOPA='('' GASSTP: --> no parameters to be varied'')')
	character*(*) FSTPNODE
	parameter (FSTPNODE='('' GASSTP: --> no degrees of freedom'')')

	include 'gasctr.icl'
	include 'gasdis.icl'
	include 'gasfit.icl'
	include 'gaspar.icl'
	include 'gaseic.icl'

        integer nfree, count
        logical silent
        real*8 dchimin, poly
	logical isensw, cancelfit
	integer ltext
	real*8 gaschi, psin, gasfun, fchisqr
	logical rep, disstep, lnc, lpbenpar, lpchiseq, lpparseq, lponce, lpout
	character nfreetext*120, textsave*128
	integer i, kk1, kk7, step, changestep
	real*8 chiold, chistep, chisqr, chisqrf, dchi, dchi0, dchisqr, flambda, x
        data lponce /.true./

        lpout = lpa .and. .not.silent
        lpchiseq = isensw(1) .and. lpout
        lpbenpar = isensw(2) .and. lpout
        lpparseq = isensw(3) .and. lpout
        disstep = isensw(9) .and. display .and. .not.silent
c        lpchiseq = .true. .and. .not.silent
c        lpbenpar = .true. .and. .not.silent
c        lpparseq = .true. .and. .not.silent
c        disstep = .true.
        lponce = lponce .and. lpchiseq
        textsave = distext
	kk1 = 2*kpeaks + 1
	if(lpbenpar)then
          write(KANAL,'('' GASSTP: starting parameters'')')
	  write(KANAL,FSTPVR) parc(2*kpeaks+2)
	  write(KANAL,FSTPVF) (brv(i),i=1,kpeaks)
	  write(KANAL,FSTPWR) parc(kk1)
	  write(KANAL,FSTPTR) (parc(2*(kpeaks+i)+8),i=0,2)
	  call gasfou(par,nctarget,brv)
	endif
c  fix everything and calculate starting chisqr
	do i=1,PARTOT
	  nc(i)=.true.
	enddo
	chisqr = fchisqr(1, irange)
        if(disstep) then
          distext = 'starting parameters'
c show display with starting parameters
          x = minreg
          do i = 1, irange
            yfa(i) = gasfun(x, npar)
	    resi(i)=(ya(i)-yfa(i))*sqrt(weight(i))
            x = x + 1.d+00
	  enddo
          distext = 'starting values'
	  call gasdis(chisqr, -3)
  	endif
c  fit loop starts here,
	step = 0
	count = 0
	do while(step.lt.MAXSTEP .and. .not.cancelfit(1))
	  kk1 = 2*kpeaks + 1
	  kk7 = kk1 + 6
c  the following texts are written if nfree <= 0
c  step must be one unit larger then the step by activation of the parameters
c  variation of the peak amplitudes
c  retry
          if(step.eq.0 .or. step.eq.3 .or. step.eq.5 .or.step.eq.7) then
            if(step.eq.3 .and. silent) step = MAXSTEP
            do i = 1, npar
              nc(i) = .true.
            enddo
            distext = ' '
            if(lponce) write(KANAL, '('' GASSTP: step'',i3'' variation of''$)') step
          else
            if(lponce) write(KANAL, '(9x''step'',i3'' adding''$)') step
          endif
c all peak amplitudes
          if(step.eq.0 .or. step.eq.3 .or. step.eq.5 .or. step.eq.7) then
            lnc = .false.
	    do i = 1, kpeaks
	      nc(kpeaks+i) = nctarget(kpeaks+i)
              lnc = lnc .or. .not.nc(kpeaks+i)
	    enddo
            if(lponce) write(KANAL, '('' - peak amplitudes''$)')
	    if(disstep .and. lnc) distext = 'peak amp. '
            nfreetext = ' GASSTP: --> no variation done'
          endif
c background polynomial
          if(step.eq.0 .or. step.eq.3 .or. step.eq.55 .or. step.eq.7) then
            lnc = .FALSE.
	    do i = 0, backdeg
	      nc(kk1+i+1) = nctarget(kk1+i+1)
              lnc = lnc .or. .not.nc(kk1+i+1)
	    enddo
            if(lnc) then
              if(lponce) then
                write(KANAL, '('' - background polynomial''$)')
              endif
	      if(disstep) distext = distext(:ltext(distext))//'+ bgr. '
            endif
          endif
c  centroids
	  if(step.eq.1 .or. step.eq.55 .or. step.eq.8) then
            lnc = .FALSE.
	    do i = 1,kpeaks
	      nc(i) = nctarget(i)
              lnc = lnc .or. .not.nc(i)
	    enddo
            if(lponce) write(KANAL, '('' - peak positions''$)')
	    if(disstep .and. lnc) distext = distext(:ltext(distext))//'+peak pos '
          endif
c  width
          if(step.eq.1 .or. step.eq.55 .or. step.eq.8) then
            nc(kk1) = nctarget(kk1)
            if(.not.nc(kk1)) then
	      if(disstep) distext = distext(:ltext(distext))//'+wi. '
              if(lponce) write(KANAL, '('' - width''$)')
            endif
          endif
c  step function
	  if(step.eq.5 .and. step.eq.8 .and. tail .and. lstep) then
            nc(kk7+6) = nctarget(kk7+6)
            if(.not.nc(kk7+6)) then
              if(disstep) distext = distext(:ltext(distext))//'+TS '
              if(lponce) write(KANAL, '('' - step function''$)')
            endif
          endif
c  background tail
	  if(step.eq.5 .and. step.eq.8 .and. tail .and. tailb) then
            nc(kk7+2) = nctarget(kk7+2)
            nc(kk7+3) = nctarget(kk7+3)
            if(.not.nc(kk7+2) .or. .not.nc(kk7+3)) then
              if(disstep) distext = distext(:ltext(distext))//'+TB '
              if(lponce) write(KANAL, '('' - background tail''$)')
            endif
          endif
c  fix width
          if(step.eq.44) then
            if(.not.(taill .or. tailr)) step = 9
            nc(kk1) = .true.
	    if(disstep) distext = distext(:ltext(distext))//'-wi. '
              if(lponce) write(KANAL, '('' - fixing width''$)')
          endif
c peak  tails
	  if(step.eq.5 .and. tail) then
            nc(kk7) = nctarget(kk7)
            nc(kk7+1) = nctarget(kk7+1)
            if(.not.nc(kk7) .or. .not.nc(kk7+1)) then
              if(disstep) distext = distext(:ltext(distext))//'+TL '
              if(lponce) write(KANAL, '('' - left peak tail''$)') 
            endif
            nc(kk7+4) = nctarget(kk7+4)
            nc(kk7+5) = nctarget(kk7+5)
            if(.not.nc(kk7+4) .or. .not.nc(kk7+5)) then
              if(disstep) distext = distext(:ltext(distext))//'+TR '
              if(lponce) write(KANAL, '('' - right peak tail''$)')
            endif
          endif
c everything but fix tail parameters if decay constant is too small
	  if(step.eq.2 .or. step.eq.4 .or. step.eq.6 .or. step.eq.9 .or. step.eq.MAXSTEP) then
            do i = 1, npar
	      nc(i) = nctarget(i)
            enddo
            if(lponce) write(KANAL, '('' - all parameters''$)')
	    if(disstep) distext = 'Variation of all parameters '
            if(tail .and. taill) then
              x = poly(parc(1), max(1, ntauleft), tauleft)*(1.d+00 + parc(kk7+1)*psin(par(kk7+1)))
              if(x.lt.0.5) then
                nc(kk7)   = .TRUE.
                nc(kk7+1) = .TRUE.
                if(lponce) write(KANAL, '('', fixing left peak tail''$)')
              endif
            endif
            if(tail .and. tailr) then
              x = poly(parc(1), max(1, ntauright), tauright)*(1.d+00 + parc(kk7+5)*psin(par(kk7+5)))
              if(x.lt.0.5) then
                nc(kk7+4) = .TRUE.
                nc(kk7+5) = .TRUE.
                if(lponce) write(KANAL, '('', fixing right peak tail''$)')
              endif
            endif
            if(tail .and. tailb) then
              x = poly(parc(1), max(1, ntauback), tauback)*(1.d+00 + parc(kk7+3)*psin(par(kk7+3)))
              if(x.lt.0.5) then
                nc(kk7+2) = .TRUE.
                nc(kk7+3) = .TRUE.
                if(lponce) write(KANAL, '('', fixing background tail''$)')
              endif
            endif
	  endif
          if(lponce) write(KANAL, '(x)')
c error messages if nfree le. 0
          if(step.eq.1) nfreetext = ' GASSTP: --> amplitudes varied only'
          if(step.eq.2) nfreetext = ' GASSTP: --> amplitudes and centroids varied only'
          if(step.eq.3) nfreetext = ' GASSTP: --> peak parameters varied only'
c
          chistep = chisqr
          changestep = STEPCOUNT*(step+1)
	  dchi0 = 2.d+00
	  dchi = DCHIMIN/((step + 1)*DCHISTEP)
	  flambda = 1.d-3 
c  determine degree of freedom
	  nfree = irange
	  do i = 1,npar
	    if(.not.nc(i)) nfree = nfree-1
	  enddo
          if(nfree.gt.0) then
	    rep = .true.
	    do while(rep .and. .not.cancelfit(1))
	      chiold = chisqr
	      chisqr = gaschi(flambda, silent)
              chisqrf = chisqr/nfree
	      count = count + 1
              if(interactiv .AND. count.eq.MAXSTEP*STEPCOUNT/2) write(*,
	1                    '('' poor convergence, please be patient'')')
              if(count.gt.changestep) then
                if(lpout .and. step.eq.MAXSTEP-1) write(KANAL, '('' GASSTP --> fit stopped because of poor convergence'')')
                if(chisqr.ge.0.d+00) chisqr = chiold
              endif
              if(chisqr.ge.0.d+00) then
  	        dchisqr = dchi0+abs((chisqr-chiold)/max(chisqr,1.d-6))/dchi
	        dchi0 = 0.d+00
c  control display
	        if(disstep .and. .not.silent .and. .not.AFTERSTEP) then
                  do i = 1, irange
	            resi(i) = (ya(i) - yfa(i))*sqrt(weight(i))
	          enddo
	          call gasdis(chisqr, -3)
		endif
                if(OUTPAR) call binparout(20, chisqrf)
	        if(lpparseq) then
                  write(KANAL,'('' GASFIT: intermediate parameters (step = '',i3)') step
                  call gasfou(par,nc,brv)
                endif
	        if(chisqr.eq.0.d+00) then
	          step = 10
	          if(lpout) write(KANAL,FSTPNOPA)
	          rep = .false.
	        else
		  rep = dchisqr.gt.1.d+00
	        end if
              endif   ! chisqr ge. 0.  
	    enddo     !  while(rep .and. .not.cancelfit(1))
	  else  !  nfree.gt.0
	    step = 10
	    if(lpout) write(KANAL,FSTPNODE) nfreetext
	  endif	! nfree.eq.0
          if(lpchiseq) then
            if(step.eq.0) then
              write(KANAL,FSTPCHG) step, count, chisqr, chistep - chisqr, chisqrf, flambda
            else
              write(KANAL,FSTPCHS) step, count, chisqr, chistep - chisqr, chisqrf, flambda
            endif
          endif
c  control display
	        if(disstep .and. .not.silent .and. AFTERSTEP) then
                  do i = 1, irange
	            resi(i) = (ya(i) - yfa(i))*sqrt(weight(i))
	          enddo
	          call gasdis(chisqr, -3)
		endif
	  step = step + 1
	enddo     ! while step.le.MAXSTEP
        lponce = .false.
c  redefine centroids 
	if(.not.poscon) then
	  do i = 1, kpeaks
	    parc(i) = parc(i) + parc(kk1 + 1)*psin(par(i))
	    par(i)=0.
	  enddo
	endif
c  get correct errors
        flambda = 0.
	chisqr = gaschi(flambda, silent)
	if(lpbenpar)then
          write(KANAL,'('' GASSTP: final parameters'')')
	  write(KANAL,FSTPVR) parc(2*kpeaks+2)
	  write(KANAL,FSTPVF) (brv(i),i=1,kpeaks)
	  write(KANAL,FSTPWR) parc(kk1)
	  write(KANAL,FSTPTR) (parc(2*(kpeaks+i)+8),i=0,2)
	  call gasfou(par,nctarget,brv)
          write(KANAL,'('' GASSTP: error of parameters'')')
	  call gasfou(dpar,nctarget,brv)
	endif
        distext = textsave
        gasstp = chisqr
        return
        end
